/*
 * txt2html.c convert a text file to html/xml
 * by Moayyad Saleh al-Sadi<errormsg@gawab.com>
 */
#include<stdio.h> /* for fopen */
#include<string.h> // for strstr()
#include<glib.h>
int main(int argc,char *argv[]) {
        gint i; gchar *filename,*oname="a.out.xml.html";
        gchar *text,*xml;
        gsize len;
        GError *error=NULL;
        FILE *f;
        gboolean v=TRUE; /* verbous */
        if (argc!=2) {
                fprintf(stderr,"syntax:\n\ttxt2html FILE\n"); return 1;
        }
       filename=argv[1];
        if (v) g_print("Creating [%s] ... ",oname);
        f=fopen(oname,"wt+");
        /* output the html header */
        fprintf(f,"
<?xml vesion='1.0' ?>
<html>
	<head>
		<title>%s</title>
	</head>
	<body>
		<div dir="ltr"><pre>\n",filename);
        /* End of html header*/
        if (v) g_print("OK\nLoading [%s] ... ",filename);
        if (!g_file_get_contents(filename,&text,&len,NULL)) {
                perror("can't open file"); return 1;
	}
	if (v) g_print("OK\nEscaping ... ");
	xml=g_markup_escape_text(text,len);
	if (v) g_print("OK\nSaving ... ");
	fprintf(f,"%s",xml);
	if (v) g_print("OK\n");
	/* output of html footer */
	fprintf(f,"
		</pre></div>
	</body>
</html>\n");
	/* End of html footer */
	if (v) g_print("OK\n");
	fclose(f);
	return 0;
}
