/* socket-common.c - add it to your project for common function */
/*
 *	Taken from GNU LIBC MANUAL
 */
#include <stddef.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>

int make_named_socket (const char *filename) {
  struct sockaddr_un name;
  int sock;
  size_t size;
  /* Create the socket. */
  sock = socket (PF_LOCAL, SOCK_DGRAM, 0);
  if (sock < 0) {
      perror ("socket"); exit (1);
  }
  /* Bind a name to the socket. */
  name.sun_family = AF_LOCAL;
  strncpy (name.sun_path, filename, sizeof (name.sun_path));
  size = SUN_LEN (&name);
  if (bind (sock, (struct sockaddr *) &name, size) < 0) {
      perror ("bind"); exit (1);
  }
  return sock;
}
int make_socket (uint16_t port) {
  int sock;
  struct sockaddr_in name;
  /* Create the socket. */
  sock = socket (PF_INET, SOCK_STREAM, 0);
  if (sock < 0) {
      perror ("socket"); exit (1);
  }
  /* Give the socket a name(any_address:port). */
  name.sin_family = AF_INET;
  name.sin_port = htons (port);
  name.sin_addr.s_addr = htonl (INADDR_ANY);
  if (bind (sock, (struct sockaddr *) &name, sizeof (name)) < 0) {
      perror ("bind"); exit (1);
  }
  return sock;
}
void init_sockaddr (struct sockaddr_in *name,const char *hostname,uint16_t port) {
  struct hostent *hostinfo;
  name->sin_family = AF_INET;
  name->sin_port = htons (port);
  hostinfo = gethostbyname (hostname);
  if (hostinfo == NULL) {
      fprintf (stderr, "Unknown host %s.\n", hostname);
      exit (1);
  }
  name->sin_addr = *(struct in_addr *) hostinfo->h_addr;
}
